#!/usr/bin/env ruby
# 
# Copyright 2008 Matthew Lee Hinman
# matthew [dot] hinman [at] gmail [dot] com
#
# Attempt to dump gzip'd data from a pcap file to stdout
# Requires Scholar's pcapparser.rb library
#

require 'pcapparser'

pp = PcapParser.new(File.new(ARGV[0]))

pnum = 0
pp.each { |pkt|
  pnum = pnum + 1
  temp = String.new(pkt.payload)
#  ID1 = 31 (0x1f, \037), ID2 = 139 (0x8b, \213)
  offset = 0
  while id = temp[offset,2]
    if (id[0].to_i == 31) && (id[1].to_i == 139)
      data = temp[offset,8192]
      f = File.new("tempfile","w")
      f.puts data
      f.close
      system("cat tempfile | gunzip -c 2>/dev/null")
    end
    offset = offset + 1
  end
}
